	.include "tnc.h"
	.area boot (abs)

start:  .org 0x0                ;[dix] first 8 bytes of code...
        di                      ;Disable interrupts for soft RESET (1b)
        im #2                   ;Zilog vectorized interrupt mode   (2b)
        xor a                   ;                                  (1b)
        ld i,a                  ;Interrupt vectors are at 0 page   (2b)
        jr      code_start      ;go around this data area          (2b)

        .org 0x8
	.globl ctc_vector
ctc_vector:             ;[dix] CTC interrput vectors
        .dw     0       ;Channels 0,1 and 2 do not generate interrupts
        .dw     0       ;so, do a soft RESET if these interrupts happens
        .dw     0
        .dw     i_ctc   ;100 Hz periodic interrupt

	.globl i_vector
i_vector:               ;SIO interrupt vectors
        .dw     ib_tbe  ;ch b transmitter buffer empty interrupt/user
        .dw     ib_ext  ;ch b ext/status change/user
        .dw     ib_rca  ;ch b received char available/user
        .dw     ib_special      ;ch b special receive condition/user

        .dw     ia_tbe  ;ch a transmitter buffer empty interrupt/modem
        .dw     ia_ext  ;ch a ext/status change/modem
        .dw     ia_rca  ;ch a received char available/modem
        .dw     ia_special      ;ch a special receive condition/modem
