	.include "tnc.h"
	.area code (rel)
;
;------------------------------------------------------------------------------
;               CONST. DATA area
;------------------------------------------------------------------------------

; sio initialize data.

	.globl a_init
a_init:         ;[jdz] Modem port init, comments by [dix]
        .db       0b00011000     ;Channel Reset command
        .db     4,0b00100000     ;CLK * 1, SYNC, SDLC
        .db     1,0b00011011     ;Enable Interrupts TX, EXT, RX (all char)
        .db     7,0b01111110     ;HDLC Flag
        .db     5,aledoff        ;TX 8 bits, TX enable, SDLC CRC, CRC enable
        .db     3,0b11001001     ;RX 8 bits, RX enable, RX CRC enable
a_end:
	a_size=a_end-a_init
	.globl a_size

	.globl b_init
b_init:         ;[jdz] TTY port init, comments by [dix]
        .db       0b00011000     ;Channel Reset command
        .db     4,0b01000100     ;CLK * 16, ASYNC, 1 STOP bit
        .db     2,i_vector       ;SIO interupt vectors table (page 0)
        .db     3,auto_enable    ;RX 8 bits, RX enable, <auto_enable>
        .db     5,bledoff        ;TX 8 bits, TX enable, DTR & RTS high
        .db     1,0b00011111     ;Enable interrupts, also Status Affects Vector
b_end:
	b_size=b_end-b_init
	.globl b_size

;	.globl msg1,msg2,msg3,msg4,msg5,msg6,msg7
	.globl msg1
msg1:   .db 0,0x86,0xa2,0x40,0x40,0x40,0x40,0xe0       ;KISS frame
        .db 0x8a,0x84,0x62,0x88,0x92,0xb0,0x61,3,0xf0 ;Beacon (UI)
        .ascii "DIXTNC KISS soft v1.9.1 from EB1DIX, enjoy it"
        .db 13,0xff
msg3:   .ascii "0 ms txdelay"
        .db 13,0xff
msg4:   .ascii "/255 persistence"
        .db 13,0xff
msg5:   .ascii "0 ms slottime"
        .db 13,0xff
msg6:   .ascii "0 ms tailtime"
        .db 13,0xff
msg7:   .ascii " full-duplex"
        .db 13,0xff
msg2:   .ascii " buffers"                   ;N of buffers
        .db 13,0xff

;this is the data area which gets blasted into ram upon startup: [jdz]
	.globl data_init
data_init:

                .db      33             ; tx delay default is 330 ms
                .db      63             ; default value for persistence
                .db      5              ; and slot time defaults to 50 ms
                .db      3              ; (should be 11 for 300 baud)
					; tail timer default
                .db      0              ;not full duplex to start
                .db      0              ; Number of buffers
                .db      0              ;means we are in recieving state
                .db      0              ;set non-zero if we're in rx state
                .dw      0              ;address of current receive buffer
                .dw      0              ;address of 1st rx buffer
                .db      0              ;is non-0 if we ran out of buffer
					;space and are currently flushing this
					;frame being received.  used by
					;ia_rca and reset by ia_ext.

                .db      0              ;tx state.
					;0 : we're not in tx state
					;1 : we're in slot time state
					;2 : we're in tx delay state
					;3 : we're in waiting cts is turn on
					;4 : we're in transmit data state
					;5 : we're in tail time state
                .db      0              ;non-zero if we've begun txing chars
                .db      0              ;number of tx cbufs queued up for tx
                .dw      tx_top  	;current active cbuf entry (if active)
                .dw      tx_top  	;next free cbuf entry
                .dw      0              ;holds address of the current buffer
					;chain head that we are transmitting
                .db      0

                .db      cts
                .db      aledoff        ;state of sta led & rts (ptt) line,
					;mainly... (for ch a only [modem] )
                .db      bledoff
;these next two are used by the ib_tbe interrupt routine.
                .db      0              ; not in escaped mode
                .db      0              ; next char to send if escaped mode
                .db      0              ; non-zero if we are in a break detect
					; sequence on the async port
                .dw      0              ;addr of current input buffer
                .dw      0              ;addr of 1st input buffer
                .db      0              ;is not 0 if we've already alloc'd buf
                .db      1              ;convert back to 1 in v.32 code
					;input state machine state
					;4 mar 8: make it 0 (from 1) becuz
					;noise on line is first triggering the
					;code to assume that a frame is coming
					;from the host.....  comment below was
					;appropriate before
					;assume that we've seen an fend from
					;(non-existent) "previous" frame. this
					;means that when we are receiving data
					;from user, there need be only the
					;fend char at the end of a frame, and
					;not at the beginning (although if a
					;fend is at the beginning, it is 
                                        ;ignored.)
                .db      0              ;output not started yet (logical var)
                .dw      out_top        ;address of buffer to be output rs232
                .dw      out_top        ;pointer to next free output buffer
                .dw      0              ;addr of buffer we are now outputting
                .dw      bottom         ;address of 1st buffer on free list

data_end:
		data_size=data_end-data_init
		.globl data_size
