	.include "tnc.h"
	.area code (REL)

;	include	ia.mac			;modem interrupt catchers
;---------------------------------------------------------------------------
	.globl ia_tbe
ia_tbe:
        ex      af,af'
        exx
	ld	a,(tx_started)
	or	a
        jr      z,ia_t2                 ; previous frame finished

	ld	hl,(tx_chain_head)
	call	getchar
	ld	(tx_chain_head),hl	; must keep this pointer updated
        jr      z,ia_t1                 ; no more to send

	out	(a_dat),a		; else ship this char out
ia_t9:
        exx
        ex      af,af'
	ei
	reti				; just return from these interrupts

ia_t1:
	xor	a
        ld      (tx_started),a          ; tx is not started
        ld      hl,#tx_outstng           ; make is so that one fewer frames
                                        ; not "(tx_outstng)" (!) 29 sep
	dec	(hl)			; are outstanding
	ld	a,#0x28
	out	(a_ctl),a		; reset tx interrupt pending
        jr      ia_t9

;previous frame is done, sio now sending a flag.  more?
ia_t2:
        ld      a,(tx_outstng)
	or	a
        jr      nz,ia_t21               ;if more to send, go there

; else we're done here, clean up.
	ld	a,#0x28
	out	(a_ctl),a		; reset tx interrupt pending

;start tail timer event
	ld	a,(tailtime)
	ld	(tx_timer),a		; wait for crc to clear tx
	ld	a,#5
	ld	(tx_state),a
        jr      ia_t9

ia_t21:                                 ; start up next frame
	call	txnext_cbuf		; get the next buffer chain pointer
					; setup hl and tx_chain_head
	ld	a,#0x80
	out	(a_ctl),a		; reset tx crc generator
	call	getchar
	out	(a_dat),a		; get 1st char of next frame
	ld	a,#true
        ld      (tx_started),a          ; tx started again
	ld	a,#0xc0
	out	(a_ctl),a		; reset tx underrun/eom latch
        jr      ia_t9

;---------------------------------------------------------------------------
; got a character from the sio rx interrupt, deal with it
; extensive mods 3 feb 87 to be in line with what i now know about sio...

	.globl ia_rca
ia_rca:
        ex      af,af'
        exx

	ld	a,(rx_flushing)
	or	a
        jr      z,ia_rc1

	in	a,(a_dat)
        jr      ia_rc9

ia_rc1:
        ld      a,(rx_allo_buf)
	or	a
        jr      nz,ia_rc7       ; go there if we are in "receiving" state

;else we are not yet receiving, so allocate buffer & make us "receiving"

        call    allo_buf	; get a new buffer
        jr      z,ia_rc5        ; no room, flush this frame

; if got a buffer, insert this character.
; after doing initial buffer setup.

ia_rc6:
	ld	(rx_head),hl	; save chain head address (1st buffer)
	ld	(rx_buf),hl	; tuck away addr of our current buffer
	ld	a,#true
        ld      (rx_allo_buf),a ; and mark that
				; we are receiving

;	ld	a,#0		; channel 0
	xor a
	call	putchar		; slip' frame "type" field here (always 0)

ia_rc7:
	in	a,(a_dat)	; grab the pending character
	ld	hl,(rx_buf)	; load up address of our current rx buffer
	call	putchar		; and stuff in this particular buffer
        jr      c,ia_rc2        ; if no room, flush this frame.
	ld	(rx_buf),hl	; hl might have changed in putchar()

ia_rc9:
        exx
        ex      af,af'

	ei
	reti				; nothing else to do here


; if no room, flush this frame (sigh)
ia_rc2:
	xor	a
        ld      (rx_allo_buf),a
	ld	hl,(rx_head)
	call	free_chain
ia_rc5:
	ld	a,#true
	ld	(rx_flushing),a		; we are in the midst of
					; flushing this frame
	call	sta_on			; ddd note that we are in flushing
					; state
        jr      ia_rc9

;---------------------------------------------------------------------------
; from out point of view, this interrupt is only interesting because it
; tells us if we're at end of frame.
	.globl ia_special
ia_special:
        ex      af,af'
        exx                     ; regs we'll need

	ld	a,#1
	out	(a_ctl),a	; ready to read rr1
	in	a,(a_ctl)	; ok, grab rr1

; first check if rx overrun.  this is very bad, so what can we do?
; well, we merely treat it as a bad crc, that is, just flushing the
; frame.  i don't like dropping chars (and it shouldn't happen very often)
; but at high speeds, it may occur with 2.5 mhz z80s.

	bit	5,a		; rx overrun?
        jr      nz,ia_sp8       ; if a problem, treat as bad crc
				; that is, flush this frame....
;ia_sp0:
	bit	7,a		; check state of end of frame bit
        jr      z,ia_sp8        ; else something weird happened - probably
				; rx overrun. in any case, flush this frame.
				; error reset & then exit
				; that is, treat like it was a crc error

; if end of frame, check crc bit for valid.
ia_sp1:
	bit	6,a		; check crc error bit
        jr      nz,ia_sp8       ; if crc error bit is on, then was crc error

; first ensure that we indeed have a buffer allocated...
        ld      a,(rx_allo_buf)
	or	a
	jr	z,ia_sp9	; if no buffer allocated, ignore this.

; else this was a good frame, and we should ship it out to host
; leave the first crc character at end of buffer chain in the buffer, as
; getchar() will flush it.

	ld	hl,(rx_head)
        call    out_queue_ins           ; shove this buffer string onto
                                        ; output queue
	xor	a
        ld      (rx_allo_buf),a         ; we don't have a buffer
                                        ; allocated for the next
                                        ; frame...
        jr      ia_sp9

; get here if there was a bad crc
ia_sp8:
        ld      a,(rx_allo_buf) ; if we don't have any
                                ; buffers allocated, then
	or	a		; 8 feb - set condition codes !!!!!!
        jr      z,ia_sp9        ; we must not "release" them !!! 10 sep 86
				; if they are not allocated !!!
	xor	a
        ld      (rx_allo_buf),a
				; not receiving if we have bad crc
	ld	hl,(rx_head)
	call	free_chain	; free up all buffer(s)

ia_sp9:
	ld	a,#0x30		; error reset
	out	(a_ctl),a
	in	a,(a_dat)	; avoid spurious rca interrupt

	ld	a,#0x03		; [js] select wr3
	out	(a_ctl),a	; [js]
	ld	a,#0xd9		; [js] enter hunt mode
	out	(a_ctl),a	; [js]
	xor	a
	ld	(rx_state),a	; [js] store sync/hunt state
	ld	(rx_flushing),a

; software dcd filter
        in      a,(switch)
        bit     7,a
        jr      z,ia_spsd

        ld      a,(full_duplex)
	or	a
        jr      nz,ia_spsd

	ld	a,(tx_state)
	cp	#2
        jr      nc,ia_spsd

	ld	a,#1
	ld	(tx_state),a
	ld	a,(slottime)
	ld	(tx_timer),a
ia_spsd:

        exx
        ex      af,af'

	ei
	reti

;---------------------------------------------------------------------------
; for ext/status interrupts on modem, get dcd state into memory, and
; deallocate any spurious buffers (buffer stuff done 30 sep 86).
	.globl ia_ext
ia_ext:
        ex      af,af'
        exx
	ld	a,#0x10		; reset ext/status interrupts
	out	(a_ctl),a
	in	a,(a_ctl)	; grab rr0
	ld	(a_rr0),a
	bit     4,a             ; [js] check sync/hunt bit
        jr      nz,ia_ex1       ; [js] no need to worry, if not zero
	ld      a,(rx_state)	; [js] it is 0! did it change?
	or      a               ; [js]
        jr      nz,ia_ex9       ; [js] no, this is a dcd,cts or eom-interrupt
	ld	a,#true		; [js] indeed, it changed!
	ld      (rx_state),a	; [js] next time, we'll know

        ld      a,(rx_allo_buf) ; if we are not in the
						; receiving state...
	or	a		; then there are no allocated buffers and...
        jr      z,ia_ex9        ; we must not "release" them !!! 10 sep 86
				; if no buffers allocated !!!
	xor	a
        ld      (rx_allo_buf),a ; not receiving
	ld	hl,(rx_head)
        call    free_chain      ; free up all buffer(s)
        jr      ia_ex9
ia_ex1:
	xor	a		; [js] prepare for next frame start
	ld	(rx_state),a	; [js]
	ld	(rx_flushing),a
ia_ex9:
        exx
        ex      af,af'
	ei
	reti


