;
;	 		kiss tnc for the tnc-2 and clones
;
; k3mc 30 sep 86 - original version
;
; 1 mar 87.  fixed all known bugs.  re-arrange code to allow roming (this
; means that data areas need to be initialized from the code).  figure out the
; stack pointer given the amount of available ram.  include the codes 05 00
; and 05 01 to mean full duplex off and full duplex on, respectively.
; clear out all available ram.  do a "dance" with leds when initially booted:
; flash the led(s) for about 5 seconds such that con only flashes if you have
; 8k ram, sta only flashes if 16k ram, and sta and con flash if 32k ram.
;
; 29 mar 87. add code to discard break chars, and chars with framing errors.
; fix bug in ib_rca which did not discard null received frames.
;
; 11 dec 89.  incorporate code from jan schiefer, dl5ue, [44.130.48.9]
; degerlocherstrasse 5, 7000 stuttgart 70, federal republic of germany
; to fix the problem with full-duplex operation.  new version number, v.4
;
; 19 jan 91. shin-ichi kanno , jn1jdz , [133.168.32.129]
; fix the dcd detection problem. add the auto-enable operation.
; add the code of output following data routine. new version number, v.5
;
; 27 jun 91. add the txdelay control . fix buffer allocation problem .
; add the code of software dcd detection routine. new version number, v.7
;
; 12 jul 95. Jesus Arias [EB1DIX]. Port to the DIX-TNC. JP's replaced by JR's
; when possible, New memory management and Z80-CTC stuff. Original code
; translated to lowercase because i'm using a case-sensitive assembler. Some
; conditional blocks eliminated. Some syntax changed. Flash the LEDs while
; booting every 2 Kb of avaiable RAM. Version 1.7
;
; 23 sep 95. Jesus Arias [EB1DIX]. New version 1.8. All interrupt routines now
; uses the alternate register set. Wellcome message at start-up.
;
; 27 Oct 95. Jesus Arias [EB1DIX]. New version 1.9. No more Flashing LEDs,
; Much more verbose startup message.
;
; 23 Dec 95. Port to XASM syntax & structure. Now it looks like great programs
; with areas, OBJ's and linker stuff. Unix Makefile included. Version 1.9.1
;

	false=0
	true=~false		;Say 0ffh or 0ffffh


;sio_auto=1			;uncomment this line to set sio port b for
	sio_auto=0		;auto-enable mode.
;ptt_low=1			;uncomment this line for PTT active low (RTS_A)
	ptt_low=0
;dcd_low=1			;uncomment this line for DCD active low
	dcd_low=0

;****** hardware dependent ******
	ram_start=0x2000	;RAM Area Start Address
;****** hardware dependent ******
	switch=0x0		;[dix] DIP Switches I/O BASE Address
;
;      SxMMMTTT    M: Modem Speed (3 bits)
;                  T: TTY Speed (3 bits)
;                  S: Soft DCD if 1, hard DCD if 0
;                  x: Don't worry
;
;       Baud Table (Note that the clock is 16 times the desired baud rate)
;
;       Bits    Speed   CTC presc.      CTC Time Const
;       000     19200           16              1
;       001     9600            16              2
;       010     4800            16              4
;       011     2400            16              8
;       100     1200            16              16
;       101     600             16              32
;       110     300             16              64
;       111     150             16              128
;
;                       (System clock is 4.9152 MHz)

;****** hardware dependent ******
	ctc=0x4		;Timer I/O BASE Adress
	ctc0=ctc	;Modem divisor
	ctc1=ctc+1	;TTY divisor
	ctc2=ctc+2	;spare channel
	ctc3=ctc+3	;Periodic interrupt

;****** hardware dependent ******
	sio=0x8		;SIO I/O BASE Address
	a_dat=sio+0	;modem port
	a_ctl=sio+1	;modem port

	b_dat=sio+2	;user serial port
	b_ctl=sio+3	;user serial port



	dcd=8		;bit in rr0, used in ch a
	cts=0x20	;bit in rr0, used in ch a

	tbe=4		;tx buffer empty bit
	rts=2		;request to send (ptt bit in wr5 of chan a)

	framing_error=0x40	;bit in rr1 for async framing error
	break_abort=0x80	;bit in rr0 for async break detection

.if sio_auto
	auto_enable=0xe1
.else
	auto_enable=0xc1
.endif

;	Special KISS Characters
	fend=0o300		;300 octal
	fesc=0o333		;333 octal
	tfend=0o334		;334 octal
	tfesc=0o335		;335 octal

.if PTT_LOW
	aledoff=0xe9            ;bits for wr5 to turn off sta led
.else
	aledoff=0xeb
.endif

	aled=0x80		;the DTR bit in ch a wr5, we will soon remove
				;previous 2 definitions & use the memory loc.
				;a_wr5 to hold ch a wr5's value, because we
				;need to be aware when we are transmitting!

	bledoff=0xea            ;bits for wr5 to turn off con led
	bled=0x82		;We use RTSB & DTRB for BLED, because
                                ;SIO-1 lacks DTRB [dix]

