	.include "tnc.h"
	.area code (REL)
;-----------------------------------------------------------------------------
;               LED related stuff
;-----------------------------------------------------------------------------

	.globl sta_on
sta_on:		;turn the sta led on.  assumes that interrupts are disabled!
	push	af
	ld	a,#5
	out	(a_ctl),a		; ready to write wr5
	ld	a,(a_wr5)		; get memory copy
        and     #~aled                  ; set dtr bit to 0 so led goes on
	out	(a_ctl),a		; actually turn on sta led now...
	ld	(a_wr5),a		; update memory copy
	pop	af
	ret
;-----------------------------------------------------------------------------
	.globl sta_off
sta_off:	;turn the sta led off.  assumes that interrupts are disabled!
	push	af
	ld	a,#5
	out	(a_ctl),a		; ready to write wr5
	ld	a,(a_wr5)		; get memory copy
	or	#aled			; set dtr bit to 1 so led goes off
	out	(a_ctl),a		; actually turn off sta led now...
	ld	(a_wr5),a		; update memory copy
	pop	af
	ret

;these routines must be called with interrupts disabled!
;-----------------------------------------------------------------------------
	.globl con_on
con_on:
        push    af
	in	a,(b_ctl)		;assure we are talking to ch 0
	ld	a,#5
	out	(b_ctl),a		; ready to write wr5
	ld	a,(b_wr5)		; get memory copy
        and     #~bled                  ; [dix]
        out     (b_ctl),a               ; actually turn on con led now...
	ld	(b_wr5),a		; update memory copy
	pop	af
        ret

;-----------------------------------------------------------------------------
	.globl con_off
con_off:
        push    af
	in	a,(b_ctl)		;assure we are talking to ch 0
	ld	a,#5
	out	(b_ctl),a		; ready to write wr5
	ld	a,(b_wr5)		; get memory copy
        or      #bled                   ; [dix]
	out	(b_ctl),a		; actually turn off con led now...
	ld	(b_wr5),a		; update memory copy
	pop	af
        ret

;-----------------------------------------------------------------------------
;       Utility routines
;---------------------------------------------------------------------------
;
; prtn  prints the value of A in decimal, using the putchar routine, so
; HL    must point to the buffer where the number will be printed
;

	.globl prtn
prtn:   push bc                         ;save registers...
        push de
        push af
        ld b,#100                       ;first divisor
        ld e,#0                         ;flag to skip left 0's
        ld d,a
        or a
        jr z,trick
npr:    ld c,#0
npr1:   sub b                           ;divive (nbuffers) by 100, 10 or 1
        inc c                           ;INC doesn't change Carry Flag
        jr nc,npr1
        dec c
        add a,b                         ;A holds the remainder of divison
        ld d,a                          ;... a temporal copy of A ...
        ld a,c
        or e
        jr z,npr2                       ;if first chars=0 nothing to print
        ld e,#true                      ;print last 0's
        ld a,c
trick:  add a,#'0                       ;ASCII code of digit
        call putchar                    ;send character to buffer
npr2:   ld a,b
        ld c,#0
div10:  sub #10                         ;divide B by 10
        inc c                           ;INC doesn't change Carry Flag
        jr nc,div10
        ld a,d
        dec c                           ;If divisor=0 end printing number
        ld b,c
        jr nz,npr
        pop af
        pop de
        pop bc
        ret

;puts   puts the char string pointed by DE, and terminated by 0xff to
;       the buffer pointed by HL
;       DE points to following string at the exit

	.globl puts
puts:   push af
bputs:  ld a,(de)
        inc de
        cp #0xff
        jr nz,sputs
        pop af
        ret
sputs:  call putchar
        jr bputs


