	.include "tnc.h"
;*************** RAM AREA **********************

	.area RAM (ABS)
	.org ram_start

	.globl txdelay,persistence,slottime,tailtime,full_duplex,nbuffers
	.globl rx_state,rx_allo_buf,rx_buf,rx_head,rx_flushing

txdelay:         .ds 1          ; tx delay default is 330 ms
persistence:     .ds 1          ; default value for persistence
slottime:        .ds 1          ; and slot time defaults to 50 ms
tailtime:        .ds 1          ; (should be 11 for 300 baud)
				; tail timer default
full_duplex:     .ds 1          ;not full duplex to start
nbuffers:        .ds 1          ; Number of buffers
rx_state:        .ds 1          ;means we are in recieving state
rx_allo_buf:     .ds 1          ;set non-zero if we're in rx state
rx_buf:          .ds 2          ;address of current receive buffer
rx_head:         .ds 2          ;address of 1st rx buffer
rx_flushing:     .ds 1          ;is non-0 if we ran out of buffer
				;space and are currently flushing this
				;frame being received.  used by
				;ia_rca and reset by ia_ext.

	.globl tx_state,tx_started,tx_outstng,tx_head_cbuf,tx_tail_cbuf
	.globl tx_chain_head,tx_timer

tx_state:        .ds 1          ;tx state.
				;0 : we're not in tx state
				;1 : we're in slot time state
				;2 : we're in tx delay state
				;3 : we're in waiting cts is turn on
				;4 : we're in transmit data state
				;5 : we're in tail time state
tx_started:      .ds 1          ;non-zero if we've begun txing chars
tx_outstng:      .ds 1          ;number of tx cbufs queued up for tx
tx_head_cbuf:    .ds 2		;current active cbuf entry (if active)
tx_tail_cbuf:    .ds 2		;next free cbuf entry
tx_chain_head:   .ds 2          ;holds address of the current buffer
				;chain head that we are transmitting
tx_timer:        .ds 1

	.globl a_rr0,a_wr5,b_wr5
a_rr0:           .ds 1
a_wr5:           .ds 1		;state of sta led & rts (ptt) line,
				;mainly... (for ch a only [modem] )
b_wr5:           .ds 1
	.globl out_esc_mode,out_char,in_break,in_buffer,in_head,in_allo_buf
	.globl in_state
;these next two are used by the ib_tbe interrupt routine.
out_esc_mode:    .ds 1	        ; not in escaped mode
out_char:        .ds 1          ; next char to send if escaped mode
in_break:        .ds 1          ; non-zero if we are in a break detect
				; sequence on the async port
in_buffer:       .ds 2          ;addr of current input buffer
in_head:         .ds 2          ;addr of 1st input buffer
in_allo_buf:     .ds 1          ;is not 0 if we've already alloc'd buf
in_state:        .ds 1          ;convert back to 1 in v.32 code
				;input state machine state
				;4 mar 8: make it 0 (from 1) becuz
				;noise on line is first triggering the
				;code to assume that a frame is coming
				;from the host.....  comment below was
				;appropriate before
				;assume that we've seen an fend from
				;(non-existent) "previous" frame. this
				;means that when we are receiving data
				;from user, there need be only the
				;fend char at the end of a frame, and
				;not at the beginning (although if a
				;fend is at the beginning, it is 
                                ;ignored.)
	.globl out_started,out_head_cbuf,out_tail_cbuf,out_ch_head,free
out_started:     .ds 1          ;output not started yet (logical var)
out_head_cbuf:   .ds 2	    	;address of buffer to be output rs232
out_tail_cbuf:   .ds 2		;pointer to next free output buffer
out_ch_head:     .ds 2          ;addr of buffer we are now outputting
free:		 .ds 2          ;address of 1st buffer on free list

;************ queue spaces **************

	.globl tx_top,tx_bottom
	.globl out_top,out_bottom

tx_top: 	.ds 2*255	;"top" of output circular queue
                                ; 255 out buffer chains pending, max
tx_bottom: 	.ds 2	     	;"bottom" of output circular buffer

out_top: 	.ds 2*255	;The other queue....
out_bottom: 	.ds 2		;"bottom" of this queue

;***************************************************************************
;	out = to tty port; in = from tty port
;	tx = to modem; rx = from modem
;
;	; means that that code executes without interrupts enabled (except
;	    for the initialization code)
;*********** End of variables = start of buffer area ************
	.globl bottom
bottom:				;end of all RAM data variables & queues
                                ;start of RAM data buffers chain

